from AccessControl.SecurityInfo import ClassSecurityInfo
from Globals import DTMLFile
from Products.PluggableAuthService.utils import classImplements
from Products.PluggableAuthService.plugins.BasePlugin import BasePlugin
from Products.PluggableAuthService.interfaces.plugins import \
                IChallengePlugin

manage_addNoGoChallengerForm=DTMLFile("../zmi/challenger", globals())

def manage_addNoGoChallenger(self, id, title='', path='/', REQUEST=None):
    """Add a NoGoChallenger to a Pluggable Authentication Service.
    """
    c=NoGoChallenger(id, title, path)
    self._setObject(c.getId(), c)

    if REQUEST is not None:
        REQUEST["RESPONSE"].redirect("%s/manage_workspace"
                "?manage_tabs_message=NoGo+challenger+added." % 
                self.absolute_url())


class NoGoChallenger(BasePlugin):
    """Simple challenge plugin giving a static no-access page.
    """

    meta_type = "No-go challenger plugin"
    security = ClassSecurityInfo()

    _properties = (
            { "id"    : "title",
              "label" : "Title",
              "type"  : "string",
              "mode"  : "w",
            },
            { "id"    : "path",
              "label" : "Path to error message",
              "type"  : "string",
              "mode"  : "w",
            }
            )

    def __init__(self, id, title=None, path="/"):
        self._setId(id)
        self.title=title
        self.path=path

    def challenge(self, request, response):
        response.redirect(self.path, lock=1)
        return True


classImplements(NoGoChallenger, IChallengePlugin)

# vi: sw=4 expandtab
